// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License.
// See LICENSE.TXT for details.
//

package de.uka.ilkd.asmkey.logic;


import de.uka.ilkd.key.logic.sort.Sort;


/** Formal parameters of named asm rules. Instances of this class
 * represents formal parameters in named asm rules. They are similar
 * to logical variables, but may only occur in definitions of named
 * asm rules.  Formal parameters are replaced with concrete arguments
 * on rule invocation (inlining). */

public final class FormalParameter extends AsmOperator {

    /** creates a new formal parameter with the given name and given
     * sort. */
    public FormalParameter(String id, Sort sort) {
        super(id, sort);
    }

}
