// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

/* Generated by Together */

package de.uka.ilkd.key.casetool;


public class DefaultReprModelMethodImpl implements ReprModelMethod {


    private ReprModelClass containingClass;
    private String name;
    private boolean isVoid;
    private String precond = "";
    private String postcond = "";
    private ReprModelMethod method;

    DefaultReprModelMethodImpl(ReprModelClass containingClass,
			       ReprModelMethod method,
			       String name,
			       boolean isVoid) {
	this.method = method;
	this.containingClass = containingClass;
	this.name = name;
	this.isVoid = isVoid;	
    }

    public ReprModelClass getContainingClass() {
	return containingClass;
    }

    public String getContainingClassName() {
	return containingClass.getClassName();
    }

    public String getContainingPackage() {
	return containingClass.getContainingPackage();
    }
    
    public String getCallSignature() {
	return method.getCallSignature();
    }

    public String getCallSignature(boolean translateJavaType2OCLTypes) {
	return method.getCallSignature(translateJavaType2OCLTypes);
    }

    public String getName() {
	return name;
    }

    public boolean isVoid() {
	return isVoid;
    }
      
    public String getMyPreCond() {
	return precond;
    }

    public void setMyPreCond(String precond) {
	this.precond = precond;
    }

    public String getParentPreCond() {
	return method.getMyPreCond();
    }

    public String getMyPostCond() {
	return postcond;
    }

    public void setMyPostCond(String postcond) {
	this.postcond = postcond;
    }

    public String getParentPostCond() {
	return method.getMyPostCond();
    }

    public String getMyGFAbs() {
	throw new RuntimeException("Method getMyGFAbs not "+
				   "implemented in this default "+
				   "implementation.");
    }

    public void setMyGFAbs(String abs) {
	throw new RuntimeException("Method setMyGFAbs not "+
				   "implemented in this default "+
				   "implementation.");
    }

    public String getActXmifile() {
	throw new RuntimeException("Method getActXmifile not "+
				   "implemented in this default "+
				   "implementation.");
    }

    public boolean hasOrigParent() {
	throw new RuntimeException("Method hasOrigParent not "+
				   "implemented in this default "+
				   "implementation.");
	//	return hasOrigParent;
    }
}
