// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

/* Generated by Together */

/*
 * ReprModelClass represents a UML class modeled in the
 * casetool.
 *
 * Bug: Interfaces are not considered yet. (See also comment
 *      in together.TogetherReprModelClass.
 *      Consequentely, classes have only one parent.
 */


package de.uka.ilkd.key.casetool;

import java.util.Vector;
import de.uka.ilkd.key.casetool.HashMapOfClassifier;

public interface ReprModelClass extends ReprModel {
    public String getClassName();

    public String getFullClassName();


    // returns the invariant of the class if any, else ""
    public String getMyInv();

	// set the (OCL) invariant of the class
	public void setMyInv(String inv);
	
	// set the GF abstract syntax for the invariant of the class
	public void setMyInvGFAbs(String inv);

	// get the GF abstract syntax for the invariant of the class
	public String getMyInvGFAbs();
    
    //returns the package containing this class. If there
    // is none, returns null
    public String getContainingPackage();

    // return the invariant of the parent if any, else ""
    public String getParentInv();
    
    // return the classname of the parent if any, else ""
    public String getParentClassName();

    // returns true if class has a parent
    public boolean hasOrigParent();


    // calls getOpNames on parent if any, else returns null
    public Vector getParentOpNames();


    // calls getOps on parent if any, else returns null
    public Vector getParentOps();


    public Vector getOpNames();

     // returns ReprModelMethod
    public Vector getOps();

    public void getAssociations(HashMapOfClassifier 
						 classifiers);

    public String getText();

    String[] getClassesInPackage();

    public String getRootDirectory();

}
