// The KeY system is protected by the GNU General 
// Public License. See LICENSE.TXT for details.
//

package de.uka.ilkd.key.casetool.together;

import de.uka.ilkd.key.casetool.UMLOCLAssociation;
import de.uka.ilkd.key.casetool.UMLOCLMultiplicity;
import de.uka.ilkd.key.casetool.UMLOCLClassifier;


public class UMLOCLTogetherAssociation implements UMLOCLAssociation {

    private static final boolean DEBUG = false;

    private UMLOCLClassifier source, target;
    private String sourceRole, targetRole;
    private UMLOCLMultiplicity sourceMult, targetMult;

    public UMLOCLTogetherAssociation(UMLOCLClassifier source,
				     String sourceRole,
				     UMLOCLMultiplicity sourceMult,
				     UMLOCLClassifier target,
				     String targetRole,
				     UMLOCLMultiplicity targetMult) {
	if (DEBUG)
	    System.out.println("creating an association from "+
			       source.getName()+" to "+target.getName());
	this.source = source;
	this.target = target;
	this.sourceRole = sourceRole; 
	this.targetRole = targetRole; 
	this.sourceMult = sourceMult;
	this.targetMult = targetMult;
    }

    public UMLOCLClassifier getSource() {
	return source;
    }

    public UMLOCLClassifier getTarget() {
	return target;
    }

    public UMLOCLMultiplicity getSourceMultiplicity() {
	return sourceMult;
    }

    public UMLOCLMultiplicity getTargetMultiplicity() {
	return targetMult;
    }

    public String getSourceRole() {
	return sourceRole;
    }

    public String getTargetRole() {
	return targetRole;
    }

}
