// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

/** @author Kristofer Johannisson */

package de.uka.ilkd.key.casetool.together.scripts.menuextension;

// import de.uka.ilkd.key.casetool.FunctionalityOnModel;
import de.uka.ilkd.key.casetool.ReprModelMethod;
import de.uka.ilkd.key.ocl.gf.GFinterface;
import de.uka.ilkd.key.ocl.gf.CallbackPrePost;

public class OpMenuPoint6 extends OpMenu {
    public String getMenuEntry(){
	return "Edit Pre/Postcondition [GF]";
    }

    protected String runCore(ReprModelMethod aReprModelMethod){
    	System.out.println("Class: " + aReprModelMethod.getContainingClassName());
		System.out.println("Signature: " + aReprModelMethod.getCallSignature());
        return ((new GFinterface()).editPrePost(
        	aReprModelMethod.getContainingClassName(),
        	aReprModelMethod.getCallSignature(),
        	aReprModelMethod.getMyPreCond(),
        	aReprModelMethod.getMyPostCond(),
        	aReprModelMethod.getMyGFAbs(),
        	new CallbackPrePost(aReprModelMethod)));
    }
}
