// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.gui;
/** this class implements a TreeModel that can be displayed using the
 * JTree class framework 
 */
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;

import de.uka.ilkd.key.proof.Proof;
import de.uka.ilkd.key.proof.Node;
import de.uka.ilkd.key.proof.IteratorOfNode;

class GUIProofTreeNode extends GUIAbstractTreeNode 
                       implements TreeNode, java.io.Serializable {

    private GUIProofTreeModel tree;
    private Node node;
    
    public GUIProofTreeNode(GUIProofTreeModel tree, Node node) {
	this.tree = tree;
	this.node = node;
    }


    public TreeNode getChildAt(int childIndex) {
	return null;
    }

    public int getChildCount() {
	return 0;
    }

    public TreeNode getParent() {
	Node n = node;
	while (n.parent()!=null
	       && n.parent().childrenCount()==1) {
	    n = n.parent();
	}
	return tree.findBranch(n);
    }
    
    public boolean isLeaf() {
	return true;
    }

    public Node node() {
	return node;
    }

    public String toString() {
	return node.sequent().toString();
    }
    
}
