// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.gui;

import de.uka.ilkd.key.util.KeYResourceManager;
import java.awt.*;
import javax.swing.*;

public class IconFactory {

    static KeYResourceManager resManager = KeYResourceManager.getManager();

    private static Image keyHole=getImage("images/ekey-mono.gif");
    private static Image keyHoleClosed=getImage("images/keyproved.gif");
    private static Image keyLogo=getImage("images/key-color.gif");
    private static Image keyLogoSmall=getImage("images/key-color-icon-square.png");
    private static Icon provedFolderIcon=KeYFolderIcon.getKeYFolderIconClosed();
    private static Icon closableFolderIcon=KeYFolderIcon.getKeYFolderIconClosable();

    public static Image getImage(String s) {
	ImageIcon ii=resManager.createImageIcon(IconFactory.class, s);
	Image im=ii.getImage();
	return im;
    }

    public static ImageIcon scaleIcon(Image im, int x, int y) {
	Image scaledim=im.getScaledInstance(x,y,Image.SCALE_AREA_AVERAGING);
	return new ImageIcon(scaledim);
    }

    public static ImageIcon keyHole(int x, int y) {
	return scaleIcon(keyHole,x,y);
    }

    public static ImageIcon keyHoleClosed(int x, int y) {
	return scaleIcon(keyHoleClosed,x,y);
    }
    
    public static ImageIcon keyLogo(int x, int y) {
	return  scaleIcon(keyLogo,x,y);
    }

    public static Icon provedFolderIcon() {
	return provedFolderIcon;
    }
    
    public static Icon closableFolderIcon() {
	return closableFolderIcon;
    }
    
    public static Image keyLogo() {
	return keyLogoSmall;
    }

    
}
