// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.gui;
import java.util.EventListener;

/** InteractiveProofListener defines the interface 
 * for an object that listens to the state of an interactive proof
 */
public interface InteractiveProofListener {

    /** invoked if automatic execution has started
     */
    public void autoModeStarted(ProofEvent e);

    /** invoked if automatic execution has stopped
     */
    public void autoModeStopped(ProofEvent e);
    
    /** invoked when a rule has been applied */
    public void ruleApplied(ProofEvent e);
} 
