// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.gui;

import de.uka.ilkd.key.rule.strategy.proofevent.RuleAppInfo;


/** an object indicating that a proof event has happpend */
public class ProofEvent {
    
    private InteractiveProver source;

//    private String message="";


    /** creates a new proof event with the interactive prover where the
     * event initially occured
     * @param source 
     */
    public ProofEvent(InteractiveProver source) {
	this.source = source;
    }
    
    
    /** creates a new proof event the interactive prover where the
     * event initially occured 
     * @param source 
     * @param message a String message
    public ProofEvent(InteractiveProver source, String message) {
	this.source = source;
	this.message = message;
    }
     */


    /** the interactive prover where the event initially occured
     * @return the interactive prover where the event initially
     * occured
     */
    public InteractiveProver getSource() {
	return source;
    }
    
/*
    public String getMessage() {
	return message;
    }
*/


    /**
     * This information should have its own event, but is currently
     * propagated via this one
     */
    public RuleAppInfo getRuleAppInfo () {
	return ruleAppInfo;
    }

    public ProofEvent(InteractiveProver source,
		      RuleAppInfo       rai) {
	this ( source );
	ruleAppInfo = rai;
    }    

    private RuleAppInfo ruleAppInfo = null;

}
