// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.gui;

import de.uka.ilkd.key.logic.ConstrainedFormula;
import de.uka.ilkd.key.logic.Constraint;


/**
 * One element of a sequent as delivered by SequentPrintFilter
 */

public interface SequentPrintFilterEntry {

    /**
     * Formula to display
     */
    public ConstrainedFormula getFilteredFormula   ();

    /**
     * Original formula from sequent
     */
    public ConstrainedFormula getOriginalFormula   ();

    /**
     * Constraint for metavariable instantiations
     */
    public Constraint         getDisplayConstraint ();

}
