// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
/** represents a java label
 */
package de.uka.ilkd.key.java;

import de.uka.ilkd.key.java.visitor.Visitor;
public interface Label extends de.uka.ilkd.key.java.TerminalProgramElement {

    public Comment[] getComments();

    public SourceElement getFirstElement();

    public SourceElement getLastElement();

    public void prettyPrint(PrettyPrinter w) throws java.io.IOException;

    public void visit(Visitor v);

    public Position getStartPosition();

    public Position getEndPosition();

    public Position getRelativePosition();

}
