// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

// This file is part of the COMPOST library, (c) 1999 Universitaet Karlsruhe.
// Modified by KeY

package de.uka.ilkd.key.java.abstraction;

import de.uka.ilkd.key.java.reference.TypeReference;

/**
   A program model element representing array types.
 */
public interface ArrayType extends Type {

    /**
     * returns the type reference to the arrays base type
     * @return the type reference to the arrays base type
     */
    public TypeReference getBaseType();

    /**
     * returns the dimension of the array 
     * @return an int containing the array's dimension
     */
    public int getDimension();

    /**
     * name of the array type
     */
    public String getName();

    /**
     * full nam eof the array type
     */
    public String getFullName();
}
