package de.uka.ilkd.key.java.recoderext;

import de.uka.ilkd.key.util.Debug;
import recoder.*;
import recoder.abstraction.*;
import recoder.java.*;
import recoder.java.declaration.*;
import recoder.java.declaration.modifier.*;
import recoder.java.expression.operator.*;
import recoder.java.expression.literal.*;
import recoder.java.reference.FieldReference;
import recoder.java.reference.ReferencePrefix;
import recoder.java.reference.TypeReference;
import recoder.kit.TwoPassTransformation;
import recoder.list.ClassTypeList;
import java.util.*;

/**
 */
public abstract class ImplicitMethodBuilder {

    protected CrossReferenceServiceConfiguration services;

    public ImplicitMethodBuilder
	(CrossReferenceServiceConfiguration services) {	
	this.services = services;
    }

    /** 
     * returns the superclass of the given class type 
     * @return the superclass of the given class type 
     */
    protected ClassType getSuperclass(ClassType classType) {
	ClassTypeList superTypes = services.
	    getCrossReferenceSourceInfo().getSupertypes(classType);
	for (int i = 0; i<superTypes.size(); i++) {
	    if (!superTypes.getClassType(i).isInterface()) {
		return superTypes.getClassType(i);
	    }
	}
	return null;
    }

    protected FieldReference attribute
	(ReferencePrefix prefix, VariableSpecification spec) {
	return new FieldReference(prefix, spec.getIdentifier());
    }

    protected CopyAssignment assign(Expression lhs, Expression rhs) {
	return new CopyAssignment(lhs, rhs);
    }

    protected LocalVariableDeclaration declare
	(String name, ClassType type) {
	return new LocalVariableDeclaration
	    (new TypeReference(new Identifier(type.getName())), 
	     new Identifier(name));
    }

    public abstract MethodDeclaration createMethod(recoder.kit.TwoPassTransformation pass,
						   TypeDeclaration type);


}
