// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

// This file is part of the RECODER library and protected by the LGPL.
package de.uka.ilkd.key.java.recoderext;

import recoder.*;
import recoder.io.*;
import recoder.service.*;

public class SchemaCrossReferenceServiceConfiguration
    extends KeYCrossReferenceServiceConfiguration {
  
    public SchemaCrossReferenceServiceConfiguration() {
	super();
	getChangeHistory().removeChangeHistoryListener
	    ((ChangeHistoryListener)servConf.getCrossReferenceSourceInfo()); 
    }

    /** we need another factory for some new program elements */
    protected ProgramFactory makeProgramFactory() {
	return SchemaJavaProgramFactory.getInstance();
    }

    /**
       The cross reference source info is a subclass of the source info,
       so this class simply overrides the source info factory method.
     */
    protected SourceInfo makeSourceInfo() {
	if (servConf==null) {
	    servConf = new recoder.CrossReferenceServiceConfiguration();
	}
 	return new SchemaCrossReferenceSourceInfo
 	    (servConf.getCrossReferenceSourceInfo());
    }  
 

}

