// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
package de.uka.ilkd.key.java.recoderext;

import recoder.service.*;
import de.uka.ilkd.key.logic.*;
import recoder.abstraction.*;
import recoder.java.reference.TypeReference;
import recoder.java.declaration.VariableSpecification;

public class SchemaCrossReferenceSourceInfo extends KeYCrossReferenceSourceInfo {
    
    protected final PrimitiveType recoderTypeSVType;

    public SchemaCrossReferenceSourceInfo(CrossReferenceSourceInfo cinfo) {
	super(cinfo);
	recoderTypeSVType 
	    = new PrimitiveType("TypeSV", this);
    }

    

    public Type getType(TypeReference tr) {
	if (tr instanceof TypeSVWrapper) {
	    return recoderTypeSVType;
	} else {
	    return super.getType(tr);
	}
    }

    public Type getType(VariableSpecification vs) {
	if (vs.getExpressionCount()>0 
	    && vs.getExpressionAt(0) instanceof ProgramVariableSVWrapper) {
	    return recoderTypeSVType;
	} else {
	    return super.getType(vs);
	}
    }


}

