// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//


package de.uka.ilkd.key.java.reference;

import de.uka.ilkd.key.java.abstraction.KeYJavaType;
import de.uka.ilkd.key.java.abstraction.ArrayType;
import de.uka.ilkd.key.logic.ProgramElementName;
import de.uka.ilkd.key.util.ExtList;

public class TypeRef extends TypeReferenceImp {

    private KeYJavaType kjt = null;

    public TypeRef(KeYJavaType kjt) {
	this(kjt, 0);
    }

    public TypeRef(KeYJavaType kjt, int dim) {
	super(new ProgramElementName(kjt.getFullName()), 
	      dim, null);
	this.kjt = kjt;
    }

    public TypeRef(ProgramElementName name, 
		   int dimension, 
		   ReferencePrefix prefix,
		   KeYJavaType kjt) {
	super(name, dimension, prefix);
	this.kjt = kjt;
    }

    public KeYJavaType getKeYJavaType() {
	return kjt;
    }

}
