// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//


package de.uka.ilkd.key.java.reference;

import de.uka.ilkd.key.java.*;
import de.uka.ilkd.key.util.ExtList;

/**
 *  Type reference container.
 *  
 */

public interface TypeReferenceContainer extends NonTerminalProgramElement {

    /**
     *      Get the number of type references in this container.
     *      @return the number of type references.
     */
    int getTypeReferenceCount();

    /*
      Return the type reference at the specified index in this node's
      "virtual" type reference array.
      @param index an index for a type reference.
      @return the type reference with the given index.
      @exception ArrayIndexOutOfBoundsException if <tt>index</tt> is out
      of bounds.
    */
    TypeReference getTypeReferenceAt(int index);
}
