// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

// This file is part of the COMPOST library, (c) 1999 Universitaet Karlsruhe.

package de.uka.ilkd.key.java.statement;

import de.uka.ilkd.key.java.*;
import de.uka.ilkd.key.util.ExtList;
import de.uka.ilkd.key.java.visitor.Visitor;
/**
 *  Do.
 *  
 */

public class Do extends LoopStatement {

    /**
     *      Do.
     */
    public Do() {
	super();
    }

    /**
     *      Do.
     *      @param guard an expression.
     */
    public Do(Expression guard) {
        super(guard);
    }

    /**
     *      Do.
     *      @param guard an expression.
     *      @param body a statement.
     */

    public Do(Expression guard, Statement body) {
        super(guard, body);
    }

 
    public SourceElement getLastElement() {
        return this;
    }

    /**
     *      Is exit condition.
     *      @return the boolean value.
     */
    public boolean isExitCondition() {
        return false;
    }

    /**
     *      Is checked before iteration.
     *      @return the boolean value.
     */
    public boolean isCheckedBeforeIteration() {
        return false;
    }

    /** calls the corresponding method of a visitor in order to
     * perform some action/transformation on this element
     * @param v the Visitor
     */
    public void visit(Visitor v) {
	v.performActionOnDo(this);
    }

    public void prettyPrint(PrettyPrinter p) throws java.io.IOException {
        p.printDo(this);
    }
}
