package de.uka.ilkd.key.logic;


/**
 * This class describes the deletion strategy used by the simultan update
 * simplifier. The deletion strategy removes updates (or parts of a simultaneous
 * one) if e.g. there exists an update like {x:=x} or the location in the update
 * is not refered to during the rest of the term behind the update.
 */
public interface DeletionStrategy {

    public abstract DeletionStrategy copy();
    public Term delete(Term t);

}
