// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.logic;

public class Name implements java.io.Serializable {
    
    protected final String nameString;

    public Name(String n) {
	nameString = (n==null) ? "_noname_" : n;
    }

    public String toString() {
	return nameString.intern();
    }

    public boolean equals(Object o) {
	if (! (o instanceof Name)) {
	    return false;
	}
	return ((Name)o).nameString.equals(nameString);
    }

    public int hashCode() {
	return nameString.hashCode();
    }

}
