// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.logic;

public class NamespaceSet {

    private Namespace varNS=new Namespace();
    private Namespace funcNS=new Namespace();
    private Namespace heurNS=new Namespace();
    private Namespace sortNS=new Namespace();
    
    public NamespaceSet() {
    }

    public NamespaceSet(Namespace varNS, Namespace funcNS, 
                        Namespace sortNS, Namespace heurNS) {
	this.varNS=varNS;
	this.funcNS=funcNS;
	this.sortNS=sortNS;
	this.heurNS=heurNS;
    }

    public Namespace variables() {
	return varNS;
    }

    public void setVariables(Namespace varNS) {
	this.varNS=varNS;
    }

    public Namespace functions() {
	return funcNS;
    }

    public void setFunctions(Namespace funcNS) {
	this.funcNS=funcNS;
    }


    public Namespace heuristics() {
	return heurNS;
    }

    public void setHeuristics(Namespace heurNS) {
	this.heurNS=heurNS;
    }


    public Namespace sorts() {
	return sortNS;
    }

    public void setSorts(Namespace sortNS) {
	this.sortNS=sortNS;
    }

    public void add(NamespaceSet ns) {
	variables().add(ns.variables());
	sorts().add(ns.sorts());
	heuristics().add(ns.heuristics());
	functions().add(ns.functions());
    }

    public NamespaceSet copy() {
	NamespaceSet c = new NamespaceSet();
	c.setSorts(sorts().copy());
	c.setHeuristics(heuristics().copy());
	c.setFunctions(functions().copy());
	c.setVariables(variables().copy());
	return c;
    }

}
