// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//


package de.uka.ilkd.key.logic;

import de.uka.ilkd.key.java.abstraction.KeYJavaType;
import de.uka.ilkd.key.java.Expression; 
import de.uka.ilkd.key.util.ExtList;
import de.uka.ilkd.key.logic.sort.PrimitiveSort;
import de.uka.ilkd.key.logic.op.Function;


/**
 * represents an object in a program. Typically a constant object as
 * created by TypeConverter
 */
public class ProgramObject extends Function implements ProgramInLogic{

    private KeYJavaType kjt;

    /** creates a ProgramObject
     * @param name String with name of the object*/
    public ProgramObject(Name name, KeYJavaType kjt) {
	super(name, kjt.getSort(), new PrimitiveSort[0]);
	this.kjt=kjt;
    }

    public KeYJavaType getKeYJavaType(Term t) {
	return kjt;
    }

    public Expression convertToProgram(Term t, ExtList list) {
	return null; //???? What to do here???? %%%%
    }

    /**
     * @return true if the value of "term" having this operator as
     * top-level operator and may not be changed by modalities
     */
    public boolean isRigid (Term term) {
	return false;
    }

}
