// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//


package de.uka.ilkd.key.logic.op;

import de.uka.ilkd.key.logic.sort.Sort;
import de.uka.ilkd.key.logic.sort.ObjectSort;
import de.uka.ilkd.key.logic.sort.GenericSort;
import de.uka.ilkd.key.logic.sort.SortDefiningSymbols;
import de.uka.ilkd.key.logic.Name;
import de.uka.ilkd.key.logic.Term;
import de.uka.ilkd.key.java.abstraction.PrimitiveType;
import de.uka.ilkd.key.java.Services;

/**
 * Objects of this class represent the (logical) instanceof-operator;
 * for each object sort such an operator exists
 */
public class InstanceofSymbol extends SortDependingFunction {

    public static final Name NAME=new Name("instance");

    public InstanceofSymbol ( Sort p_sort, Sort booleanSort) {
	super ( new Name ( "" + p_sort.name () + "::" + NAME ),
		booleanSort,
		new Sort [] { p_sort },
		NAME,
		p_sort );
    }

    /**
     * This operator can be used with arbitrary arguments (of object
     * sort)
     */
    public boolean possibleSub(int at, Term possibleSub) {
	if (possibleSub.op() instanceof SchemaVariable) {
	    return true;
	}
	return
	    possibleSub.sort() instanceof ObjectSort ||
	    possibleSub.sort() instanceof GenericSort;
    }

}
