// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

/** this class represents a logical variable */
package de.uka.ilkd.key.logic.op;

import de.uka.ilkd.key.logic.sort.Sort;
import de.uka.ilkd.key.gui.SequentPrinter;
import de.uka.ilkd.key.logic.Name;

public class LogicVariable extends TermSymbol 
    implements QuantifiableVariable, ParsableVariable, 
    LogicVariableRepresentative {

    public LogicVariable(Name name,Sort sort) {
	super(name, sort);
	if ( sort == Sort.FORMULA ) {
	    throw new RuntimeException(
		"Attempt to create logic variable of type formula");
	}
    }
    
    /** @return arity of the Variable as int */
    public int arity() {
	return 0;
    }
    
    /** toString */
    public String toString() {
	return ""+name()+":"+sort();
    }

}
