// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001 Universitaet Karlsruhe, Germany
//                    and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General 
// Public License. See LICENSE.TXT for details.
//

package de.uka.ilkd.key.logic.sort;

import de.uka.ilkd.key.logic.Name;
import de.uka.ilkd.key.logic.Namespace;
import de.uka.ilkd.key.logic.op.ListOfSortDependingSymbol;


public interface CollectionSort extends Sort {


    public de.uka.ilkd.key.logic.sort.Sort elementSort();

    /**
     * @return the sorts of the predecessors of this sort
     */
    public SetOfSort extendsSorts();

    /**
     * This is called from "AbstractNonCollectionSort" to define the
     * symbols specified by this collection sort
     * @return list of the symbols, null if something has gone wrong
     * (e.g. information about LDTs is not yet available)
     */
    public ListOfSortDependingSymbol createSymbols ();

    /**
     * @return an object of this class with elementSort().equals(p),
     * or null if such an object cannot be constructed (as p is an
     * incompatible sort)
     */
    public Sort cloneFor ( Sort p );

}
