// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//


package de.uka.ilkd.key.logic.sort;

import de.uka.ilkd.key.gui.SequentPrinter;
import de.uka.ilkd.key.logic.Named;
import de.uka.ilkd.key.logic.Name;
import de.uka.ilkd.key.logic.op.Equality;

public interface Sort extends Named {
    
    public static final Sort FORMULA=new PrimitiveSort(new Name("Formula"));
    public static final Sort NULL=new NullSortImpl(new Name("Null"));

    //%%% One might reconsider the place of this sort!
    public static final Sort TYPE=new PrimitiveSort(new Name("Type"));


    /** @return name of the Sort */
    public Name name();
    
    /**
     * @return the sorts of the predecessors of this sort
     */
    public SetOfSort extendsSorts();

    /**
     * returns true iff the given sort is a transitive supersort of this sort
     * or it is the same.
     */
    public boolean extendsTrans(Sort s);

    /** @return equality symbol of this sort */
    public Equality getEqualitySymbol();
    
}
