// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
package de.uka.ilkd.key.ocl.ocldltranslator;

/* Generated by Together */

import de.uka.ilkd.key.logic.*;
import java.util.*;


public class NewFunctionNameDeliverer {
    /** 
     * For each (used) function name there will be created a counter with the number of symbols
     * alread created for that name. Resulting name format is : name-cnt !
     */
    private Map counterForNames; // from Name to Integer ...
    
    public NewFunctionNameDeliverer(){
	counterForNames = new HashMap();
    }

    
    public String getNewFunctionNameForName(String name){
	// Check whether there is an entry for the given name, 
	// create one if necessary ...
	TermFactory tf = TermFactory.DEFAULT;
	String funcName;
    
 	if(counterForNames.containsKey(name)){
	    // enlarge counter ...
	    Integer cnt = (Integer) counterForNames.get(name);
	    Integer newCnt = new Integer(cnt.intValue() + 1);
	    counterForNames.put(name,newCnt);
	    cnt = null;
	    funcName = name + "_"+ newCnt;
	} else {
	    // create new entry ...
	    Integer newCnt = new Integer(0);
	    counterForNames.put(name,newCnt);
	    funcName = name + "_"+ newCnt;

	}
	
	return funcName;
    }

   
}
