// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
package de.uka.ilkd.key.ocl.ocldltranslator;

/* Generated by Together */

import de.uka.ilkd.key.logic.*;
import java.util.*;
import de.uka.ilkd.key.logic.sort.Sort;
import de.uka.ilkd.key.logic.op.LogicVariable;


public class NewVariableDeliverer {
    /** 
     * For each (used) sort there will be created a counter with the number of the 
     * skolemsymbol (of that sort) last generated.
     */
    private Map counterForSorts; // from Sort to Integer ...
    
    public NewVariableDeliverer(){
	counterForSorts = new HashMap();
    }

    
    public LogicVariable getNewVariableForSort(Sort sort){
	// Check whether there is an entry for the given sort, 
	// create one if necessary ...
    TermFactory tf = TermFactory.DEFAULT;
    LogicVariable lv;
    
 	if(counterForSorts.containsKey(sort)){
	    // enlarge counter ...
	    Integer cnt = (Integer) counterForSorts.get(sort);
	    Integer newCnt = new Integer(cnt.intValue() + 1);
	    counterForSorts.put(sort,newCnt);
	    cnt = null;
	    lv = new LogicVariable(new Name(sort.toString() +
							  newCnt), sort);
	} else {
	    // create new entry ...
	    Integer newCnt = new Integer(0);
	    counterForSorts.put(sort,newCnt);
	    lv = new LogicVariable(new Name(sort.toString() +
					    newCnt), sort);
	}
	
	return lv;
    }

   
}
