// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
package de.uka.ilkd.key.ocl.ocldltranslator;

import de.uka.ilkd.key.logic.*;
import de.uka.ilkd.key.logic.op.Quantifier;


/**
 * Some constants to be used for the translation of OCL expression into
 * DL formulas for the KeY-System
 */


public interface TranslationConstants  {
    
    public String PLUS = "+";
    public String BINARY_MINUS = "~d";
    public String UNARY_MINUS = "~m";
    public String MULTIPLICATION = "*";
    public String DIVISION = "/";
     
    public String LESS_THAN = "lt";
    public String LESS_OR_EQUAL_THAN = "leq";
    public String GREATER_THAN = "gt";
    public String GREATER_OR_EQUAL_THAN = "geq";


    public String COUNT = "count";
    public String CONTAINS = "contains";
    public String SIZE = "size";
    public String SUM = "sum";

    public String SET_INSERT = "insert";
    public String SET_REMOVE = "remove";
    public String SET_EMPTYSET = "emptySet";
    public String SET_UNION = "union";
    public String SET_INTERSECTION = "intersection";
    
    public String BAG_INSERT = "insert";
    public String BAG_REMOVE = "remove";
    public String BAG_EMPTYBAG = "emptyBag";
    public String BAG_UNION = "union";
    public String BAG_INTERSECTION = "intersection";

    public String SEQUENCE_AT = "at";
    public String SEQUENCE_INSERT = "append";
    public String SEQUENCE_REMOVE = "remove";
    public String SEQUENCE_EMPTYSEQUENCE = "emptySequence";
    public String SEQUENCE_UNION = "union";
    public String SEQUENCE_FIRST = "first";
    public String SEQUENCE_LAST = "last";
    public String SEQUENCE_APPEND = "append";
    public String SEQUENCE_PREPEND = "prepend";
    public String SEQUENCE_SUBSEQUENCE = "subsequence";
   
    public String INSTANCE_OF = "instanceof";
    public String IS_TYPE_OF = "isTypeOf";
    public String AS_TYPE = "asType";
    public String CREATED = "created";
    public String ALL_INSTANCES = "allInstancesOf"; 

    public String INT_MOD = "mod";
    public String INT_DIV = "div";
    public String INT_MAX = "max";
    public String INT_MIN = "min";
    public String INT_ABS = "abs";

    public String REAL_MAX = "max";
    public String REAL_MIN = "min";
    public String REAL_ABS = "abs";
    public String REAL_FLOOR = "floor";
    public String REAL_ROUND = "round";

    
    public String STRING_CONCAT = "concat";
    public String STRING_APPEND = "append";
    public String STRING_TO_UPPER = "toUpper";
    public String STRING_TO_LOWER = "toLower";
    public String STRING_SUBSTRING = "substring";
    public String STRING_EMPTYSTRING = "emptyString";

    public String BOOLEAN_AND = "jAnd";
    public String BOOLEAN_OR = "jOr";
    public String BOOLEAN_NOT = "jNot";
    public String BOOLEAN_IMPLIES = "implies";
    public String BOOLEAN_EQUALS_TO_BOOLEAN = "equals";
    public String BOOLEAN_TRUE = "TRUE";
    public String BOOLEAN_FALSE = "FALSE";

}








