// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
package de.uka.ilkd.key.ocl.ocldltranslator.control;

import de.uka.ilkd.key.ocl.ocldltranslator.*;
import de.uka.ilkd.key.ocl.ocldltranslator.heuristics.*;

/**
 * A class representing the type of the translation to be performed for an
 * OCL expression when translating an OCL constraint into another language, 
 * e.g. a logical formula of an arbitrary logical system.
 *
 * The nodes in the tree representation of the constraint that should be
 * treated in a special way will be marked by such 'colors'.
 */

public class TranslationMark {

    public static TranslationMark AS_TERM = new TranslationMark("as_term");
    public static TranslationMark AS_PREDICATE = new TranslationMark("as_predicate");
    public static TranslationMark DEFAULT = new TranslationMark("default");
    public static TranslationMark AS_NONRIGID_FUNCTION_SYMBOL = new TranslationMark("as_nonrigid_function_symbol");
    public static TranslationMark AS_BOOLEAN_TERM = new TranslationMark("as_boolean_term");
    

    String typeName;
    
    public TranslationMark(String typeName){
	this.typeName = typeName;
    }

    public String toString(){
	return typeName;
    }
    
}
