// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
package de.uka.ilkd.key.ocl.ocldltranslator.detailedocl;

import de.uka.ilkd.key.ocl.ocldltranslator.*;
import de.uka.ilkd.key.ocl.ocldltranslator.control.*;
import de.uka.ilkd.key.TogetherFacade;
import java.util.*;
import tudresden.ocl.OclTree;
import tudresden.ocl.check.types.Type;
import tudresden.ocl.parser.node.Node;
import de.uka.ilkd.key.logic.*;
import de.uka.ilkd.key.java.*;
import de.uka.ilkd.key.java.declaration.*;
import de.uka.ilkd.key.java.statement.*;
import de.uka.ilkd.key.java.expression.literal.BooleanLiteral;
import de.uka.ilkd.key.util.ExtList;

public class DetailedExprTransl extends KeyOclExpressionTranslator{


    private Vector listeners=new Vector();

    public DetailedExprTransl(OclTree constraintTree, 
				      KeyOclConstraintTranslator 
				      constraintTranslator){
	super(constraintTree, constraintTranslator);
    }

    public DetailedExprTransl(OclTree constraintTree, 
				      KeyOclConstraintTranslator 
				      constraintTranslator,
				      DefaultTranslationControl tControl){
	super(constraintTree, constraintTranslator, tControl);
    }

    public DetailedExprTransl(OclTree constraintTree,
				      KeyOclConstraintTranslator 
				      constraintTranslator,
				      Vector predefinedVarNames,
				      Vector predefinedVarTypes){
	super(constraintTree, constraintTranslator, predefinedVarNames, 
	      predefinedVarTypes);
    }

    public DetailedExprTransl(OclTree constraintTree,
				      KeyOclConstraintTranslator 
				      constraintTranslator,
				      Vector predefinedVarNames,
				      Vector predefinedVarTypes ,
				      DefaultTranslationControl tControl){

	super(constraintTree, constraintTranslator, predefinedVarNames, 
	      predefinedVarTypes, tControl);
    }

    public void addListener(OCLMod listener) {
	listeners.add(listener);
    }





    
    protected void translateFeatureCallonModelType(Node n, String featureName, 
						   Node appliedTo, 
						   Vector parameterNodes, 
						   Vector iteratorNames, 
						   boolean  featureCallWithAtPre,
						   boolean featureCallWithArrow,
						   boolean isMethodCall){

	boolean changed=false;
 	Iterator it=listeners.iterator();
 	while (it.hasNext()) {
	    OCLMod currentMod=(OCLMod)it.next();
 	    changed=currentMod.translateOCL2DL(this, n, appliedTo, featureName, 
				       parameterNodes) || changed;
 	}
	
	if (!changed) {
	    super.translateFeatureCallonModelType(n, featureName, appliedTo,
						  parameterNodes, iteratorNames,
						  featureCallWithAtPre,
						  featureCallWithArrow,
						  isMethodCall);
	}	

    }
}


