// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * 
 */
package de.uka.ilkd.key.ocl.ocldltranslator.normalize;

import tudresden.ocl.*;
import tudresden.ocl.parser.*;
import tudresden.ocl.parser.analysis.*;
import tudresden.ocl.parser.node.*;
import java.util.*;

import de.uka.ilkd.key.ocl.ocldltranslator.*;

/** prerequiste: every feature call must have an explicitly named context (-> the
 *  FeatureCallParameters object must not be direct subnode of a
 *  PrimaryExpression node)
 *  ->after DefaultContextInsertion
 *  
 * Proceeds in the same way has 'MultipleIteratorSolving', but 
 * multiple iterator for 'forAll' and 'exists' will be treated otherwise:
 * Instead of using a let-Statement, we will resolve by syntactical replacement directly.
 *  @see DefaultContextInsertion
 */
public class KeyMultipleIteratorSolving extends tudresden.ocl.normalize.MultipleIteratorSolving {

  /** @return true in order to prevent from generatin let-expressions for abbreviating the 
   * origibal collection 
   */
  protected boolean exprContainsBoundNames(final PPrimaryExpression pPrEx) {
      return true;
  }

}
