// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
package de.uka.ilkd.key.ocl.ocldltranslator.test;

import java.util.*;

import tudresden.ocl.*;
import tudresden.ocl.parser.analysis.*;
import tudresden.ocl.parser.node.*;
import tudresden.ocl.check.types.*;

import de.uka.ilkd.key.logic.*;
import de.uka.ilkd.key.*;
import java.io.*;

import de.uka.ilkd.key.ocl.ocldltranslator.*;
import de.uka.ilkd.key.ocl.ocldltranslator.heuristics.*;
import de.uka.ilkd.key.ocl.ocldltranslator.control.*;
import de.uka.ilkd.key.ocl.ocldltranslator.normalize.*;
import de.uka.ilkd.key.ocl.ocldltranslator.transform.*;

/**
 * This class represents a single test case for the transformation of OCL constraints
 * in DL formulas as used in the KeY-System.
 */
public class TransformationTestSuite {
  
    protected String name;
    protected String description;
    protected String xmi_model_file;
    protected String implementation_sources_dir;

    protected Vector testCases;
    
    public TransformationTestSuite() {
	name = "";
	description = "";
	xmi_model_file = "";
	implementation_sources_dir = "."; // null;

	testCases = new Vector();
    }
    

    public void setName(String aName){
	name = aName;
    }

    public String getName(){
	return name;
    }

    public void setDescription(String aDescr){
	description = aDescr;
    }

    public String getDescription(){
	return description;
    }
    

    public void setXMIModelFile(String fileName){
	xmi_model_file = fileName;
    }

    public String getXMIModelFile(){
	return xmi_model_file;
    }

    public void setImplementationSourcesDirectory(String fileName){
	implementation_sources_dir = fileName;
    }

    public String getImplementationSourcesDirectory(){
	return implementation_sources_dir;
    }
    
    public TransformationTestCase[] getTestCases(){
	TransformationTestCase[] result = new TransformationTestCase[testCases.size()];
	int i = 0;
	for (Enumeration e = testCases.elements() ; e.hasMoreElements(); i++){
	    result[i] = (TransformationTestCase) e.nextElement(); 
	}
	return result;
    }
   
    
    public void addTestCase(TransformationTestCase tCase){
	testCases.add(tCase);
    }
    
    

}


