// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.parser;

import antlr.*;
import java.io.IOException;

public class DeclPicker implements TokenStream {

  protected CharScanner input;
  
  private boolean copyState = false;
  private boolean finished = false;
  private Token t = null;
  private String text = null;
  

  /** Stream to read tokens from */
  public DeclPicker(CharScanner in) {
    input = in;
  }


  public Token nextToken() throws antlr.TokenStreamException {
    return input.nextToken();
  }
  
  public void mark() {
     input.mark();
  }
  
  public void capture() {
     text = input.getInputBuffer().getMarkedChars();
  }
  
  public String getText() {
     return text;
  }




  /** This makes us a stream 
  public Token nextToken() throws antlr.TokenStreamException {
    t = input.nextToken();
    if (finished) return t;
    
    if (t.getType() == KeYLexerTokenTypes.SORTS ||
        t.getType() == KeYLexerTokenTypes.FUNCTIONS ||
        t.getType() == KeYLexerTokenTypes.PREDICATES ||
        t.getType() == KeYLexerTokenTypes.SCHEMA ||
        t.getType() == KeYLexerTokenTypes.RULES ||
        t.getType() == KeYLexerTokenTypes.HEURISTICS) {
//       System.out.println("\n"); 
       copyState = true;
       input.mark();
    }

    if (t.getType() == KeYLexerTokenTypes.PROBLEM) {
       copyState = false;
       finished = true;
System.err.println(       input.getInputBuffer().getMarkedChars());
    }
    
    
//    if (copyState) {
//       System.out.print(t.getText());
//       if (t.getType() == KeYLexerTokenTypes.SEMI)
//         System.out.println();
//       else
//          System.out.print(" ");
//    }
    
    return t;
  }
*/  
  
  
}
