// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.proof;

import de.uka.ilkd.key.logic.SequentChangeInfo;

/** 
 * A change event is received by a ChangeListener and used to inform the
 * listeners that somewhere in the proof a sequent has changed (formula added,
 * removed, changed)
 */
public class AppIndexChangeEvent {


    private SequentChangeInfo sci;

    /** 
     * creates a change event 
     */
    public AppIndexChangeEvent(SequentChangeInfo sci) {
	this.sci = sci;
    }

    /**
     * returns the sequent change information object
     */
    public SequentChangeInfo sequentChangeInfo() {
	return sci;
    }

}
