// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
package de.uka.ilkd.key.proof.init;

import de.uka.ilkd.key.logic.*;
import de.uka.ilkd.key.proof.*;
import de.uka.ilkd.key.util.Debug;
import de.uka.ilkd.key.parser.*;
import de.uka.ilkd.key.java.JavaInfo;
import de.uka.ilkd.key.java.Recoder2KeY;
import de.uka.ilkd.key.casetool.*;
import com.togethersoft.openapi.ide.IdeAccess;
import java.io.*;

public class CasetoolDLPO extends KeYFile {

    private ReprModelClass aClRepr;

    public CasetoolDLPO(ReprModelClass reprModelCl, java.io.File file) {
	super(file.getName(), file);
	this.aClRepr=reprModelCl;
    }


    public void readJava() {
	if (initConfig==null) {
	    throw new IllegalStateException("KeYFile: InitConfig not set.");
	}
	Recoder2KeY r2k = new Recoder2KeY
	    (initConfig.javaInfo().getKeYProgModelInfo().getServConf(), 
	     null, "",  
	     initConfig.javaInfo().rec2key(), 
	     initConfig.javaInfo().getTypeConverter(),
	     initConfig.namespaces());
	String[] cus = aClRepr.getClassesInPackage();
	r2k.readCompilationUnitsAsFiles(cus);
    }

    private static File getUserFile(String filename) { 
	//!!! CHANGE Use File-Methods!
	String projectPath = "";	    
	String projectFilename =
	    IdeAccess.getProjectManager().getActiveProject().getFileName();
	int pathEnd = projectFilename.lastIndexOf('/');
	if (pathEnd == -1) { // no separator found
	    pathEnd = projectFilename.lastIndexOf('\\');
	    if (pathEnd == -1) { //perhaps at top
		projectPath = "";
	    }
	}
	projectPath = projectFilename.substring(0, pathEnd);
	Debug.out("Looking for user defined Rules in ", projectPath);
	File file =  new File(projectPath+"/"+filename);
	if (!file.canRead()) {
	    return null;
	}
	return file;
    }


}
