// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
package de.uka.ilkd.key.proof.init;

/** Describes if the parts of an initial configuration are to be modified
 * or not when reading input to the prover.
 */
public class ModStrategy {

    /** A constant strategy modifying always */
    public static final ModStrategy MOD_ALL=new ModStrategy();
    /** A strategy modifying only variables*/
    public static final ModStrategy NO_VARS=new ModStrategy() {
	    public boolean modifyVariables() {return false;}
	};

    /** returns true iff the heuristics namespace should be modified*/
    public boolean modifyHeuristics() {
	return true;
    }

    /** returns true iff the sorts namespace should be modified*/
    public boolean modifySorts() {
	return true;
    }

    /** returns true iff the variable namespace should be modified*/
    public boolean modifyVariables() {
	return true;
    }

    /** returns true iff the functions namespace should be modified*/
    public boolean modifyFunctions() {
	return true;
    }

    /** returns true iff the set of taclets should be modified*/
    public boolean modifyTaclets() {
	return true;
    }

    /** returns true iff the java model info  should be modified*/
    public boolean modifyJavaInfo() {
	return true;
    }


}
