// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

/** this class represents a heuristic. Taclets can belong to different
 * heuristics and are excuted automatic if these are selected. A
 * heuristic is just a name. */
package de.uka.ilkd.key.rule;

import de.uka.ilkd.key.logic.Named;
import de.uka.ilkd.key.logic.Name;
public class Heuristic implements Named {
    /** name of the heuristic */
    private Name name;

    /** creates a heuristic
     * @param name Name object that contains name of the heuristic
     */
    public Heuristic(Name name) {
	this.name=name;
    }
    
    /** gets name of the heuristic
     * @return Name object that is the name of the heuristic 
     */
    public Name name() {
	return name;
    }

    /** toString */
    public String toString() {
	return name.toString();
    }
}

